﻿//css_ref System.Data;
//css_ref System.Transactions;
//css_ref System.Xml;
//css_ref Interop.SAPbobsCOM.dll;
//css_ref log4net.dll;
//css_ref Produmex.Foundation.Data.dll;
//css_ref Produmex.Foundation.Data.Sbo.dll;
//css_ref Produmex.Foundation.dll;
//css_ref Produmex.Foundation.Sbo.dll;
//css_ref Produmex.Sbo.Logex.Data.dll;
//css_ref Produmex.Sbo.Logex.MoviantoNL.dll;

using System;
using System.Reflection;
using System.Transactions;
using Produmex.Foundation.Data.Sbo;
using Produmex.Foundation.Data.Sbo.Attributes;
using Produmex.Foundation.Data.Sbo.BusinessObjects;
using Produmex.Foundation.Data.Sbo.BusinessObjects.Convertors;
using Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions;
using Produmex.Foundation.Data.Sbo.Providers;
using Produmex.Foundation.Data.Sbo.Utilities;
using Produmex.Foundation.Diagnostics;
using Produmex.Foundation.Reflection;
using Produmex.Foundation.Resources;
using Produmex.Sbo.Logex.Data;
using Produmex.Sbo.Logex.Data.BusinessObjects;
using Produmex.Sbo.Logex.Data.BusinessObjects.Definitions;
using Produmex.Sbo.Logex.Data.BusinessObjects.Definitions.Tables;
using Produmex.Sbo.Logex.Data.Providers;
using Produmex.Sbo.Logex.MoviantoNL;
using Produmex.Sbo.Logex.MoviantoNL.BusinessObjects;
using Produmex.Sbo.Logex.MoviantoNL.BusinessObjects.Definitions;
using Produmex.Sbo.Logex.MoviantoNL.Providers;


namespace AddUpdateData
{


    class Program
    {
       

        //static string SCRIPT_ROOT = @"D:\Projects\Projects\MoviantoNL\branches\V5_6_1_PNG\src\WorkflowScripts";
        // static string CONNECTION_STRING = "Server=localhost;CompanyDB=SBODemo_US;ExtraDb=PMX_SBODemo;UseTrusted=False;DbUserName=sa;DbPassword=B1Admin;UserName=manager;Password=produmex;Pooling=True;MinPoolSize=2;MaxPoolSize=10;ServerType=MSSQL2008;DBCultureInfo=en-US;LicenseServer=localhost:30000";
        static string CONNECTION_STRING = "Server=DEV_SAP9_FR;CompanyDB=SBODemo_US_53;ExtraDb=PMX_SBODemo_53;UseTrusted=False;DbUserName=sa;DbPassword=B1Admin;UserName=manager;Password=produmex;Pooling=True;MinPoolSize=2;MaxPoolSize=10;ServerType=MSSQL2008;DBCultureInfo=en-US;LicenseServer=localhost:30000";                                         


        private static readonly ILog s_log = LogProvider.GetLogger(MethodInfo.GetCurrentMethod().DeclaringType);


        static void Main(string[] args)
        {
            using (TransactionScope scope = PmxDbConnection.GetNewTransactionScope())
            {
                using (SboConnection conn = new SboConnection(CONNECTION_STRING))
				{
					conn.Open(); //Open connection to SAP
					Console.WriteLine("Connection is open to database");

					AddUpdateExtension("DRL_IPDL", "SBO purchase delivery im-/exporter for MoviantoNL", typeof(Produmex.Sbo.Logex.MoviantoNL.Extensions.Interfacing.SboPurchaseDeliveryInterface), Produmex.Sbo.Logex.Data.BusinessObjects.Definitions.PmxExtensionTypeCodes.IINTERFACING_SBOPURCHASEDELIVERY, conn);

					AddUpdateExtension("DRL_ISDR", "PMX stock im-/exporter for MoviantoNL", typeof(Produmex.Sbo.Logex.MoviantoNL.Extensions.Interfacing.PmxStockInterface), Produmex.Sbo.Logex.Data.BusinessObjects.Definitions.PmxExtensionTypeCodes.IINTERFACING_PMXSTOCK, conn);
					AddUpdateExtension("DRL_ISQS", "PMX stock QS change importer for MoviantoNL", typeof(Produmex.Sbo.Logex.MoviantoNL.Extensions.Interfacing.PmxStockQSChangeInterface), Produmex.Sbo.Logex.Data.BusinessObjects.Definitions.PmxExtensionTypeCodes.IINTERFACING_PMXSTOCKQSCHANGE, conn);

					AddUpdateExtension("DRL_ISOR", "SBO sales order im-/exporter for MoviantoNL - IPmxSalesOrderInterface", typeof(Produmex.Sbo.Logex.MoviantoNL.Extensions.Interfacing.SboSalesOrderInterface), Produmex.Sbo.Logex.Data.BusinessObjects.Definitions.PmxExtensionTypeCodes.IINTERFACING_SBOSALESORDER, conn);
					AddUpdateExtension("DRL_IRDR", "SBO sales delivery im-/exporter for MoviantoNL", typeof(Produmex.Sbo.Logex.MoviantoNL.Extensions.Interfacing.SboSalesDeliveryInterface), Produmex.Sbo.Logex.Data.BusinessObjects.Definitions.PmxExtensionTypeCodes.IINTERFACING_SBOSALESDELIVERY, conn);

					AddUpdateExtension("DRL_ISD2", "SBO sales delivery im-/exporter for MoviantoNL - GLS", typeof(Produmex.Sbo.Logex.MoviantoNL.Extensions.Interfacing.SboSalesDelivery2Interface), Produmex.Sbo.Logex.Data.BusinessObjects.Definitions.PmxExtensionTypeCodes.IINTERFACING_SBOSALESDELIVERY2, conn);

					// SboSalesDelivery2
					AddUpdateExtensionParameter("SD2-EP",//Produmex.Sbo.Logex.Data.BusinessObjects.Definitions.PmxExtensionParameterCodes.SALES_DELIVERY2_EXPORT_PATH,
						"Custom export path",
						"DRL_ISD2",
						Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions.PmxExtensionCodes.SYSTEM_STRING_CONVERTOR,
						@"C:\Produmex\Interface\Out",
						"SD2-EP"//PmxExtensionParameterCodes.SALES_DELIVERY2_EXPORT_PATH
						, conn);


					AddUpdateExtension("DRL_ISRT", "SBO sales return im-/exporter for MoviantoNL - ROC_RETURN", typeof(Produmex.Sbo.Logex.MoviantoNL.Extensions.Interfacing.SboSalesReturnInterface), Produmex.Sbo.Logex.Data.BusinessObjects.Definitions.PmxExtensionTypeCodes.IINTERFACING_SBOSALESRETURN, conn);
					AddUpdateExtension("DRL_ISR2", "SBO sales return im-/exporter for MoviantoNL - DSP_RETURN", typeof(Produmex.Sbo.Logex.MoviantoNL.Extensions.Interfacing.SboSalesReturn2Interface), Produmex.Sbo.Logex.Data.BusinessObjects.Definitions.PmxExtensionTypeCodes.IINTERFACING_SBOSALESRETURN2, conn);

					AddUpdateExtension("DRL_IPOR", "SBO purchase order im-/exporter for MoviantoNL", typeof(Produmex.Sbo.Logex.MoviantoNL.Extensions.Interfacing.SboPurchaseOrderInterface), Produmex.Sbo.Logex.Data.BusinessObjects.Definitions.PmxExtensionTypeCodes.IINTERFACING_SBOPURCHASEORDER, conn);


					AddUpdateExtension("DRL_IPDI", "SBO goods issue im-/exporter for MoviantoNL", typeof(Produmex.Sbo.Logex.MoviantoNL.Extensions.Interfacing.SboGoodsIssueInterface), Produmex.Sbo.Logex.Data.BusinessObjects.Definitions.PmxExtensionTypeCodes.IINTERFACING_SBOGOODSISSUE, conn);
					AddUpdateExtension("DRL_IPDR", "SBO goods receipt im-/exporter for MoviantoNL", typeof(Produmex.Sbo.Logex.MoviantoNL.Extensions.Interfacing.SboGoodsReceiptInterface), Produmex.Sbo.Logex.Data.BusinessObjects.Definitions.PmxExtensionTypeCodes.IINTERFACING_SBOGOODSRECEIPT, conn);

					AddUpdateExtension("DRL_ISIN", "SBO sales invoice im-/exporter for MoviantoNL", typeof(Produmex.Sbo.Logex.MoviantoNL.Extensions.Interfacing.SboSalesInvoiceInterface), Produmex.Sbo.Logex.Data.BusinessObjects.Definitions.PmxExtensionTypeCodes.IINTERFACING_SBOSALESINVOICE, conn);
					AddUpdateExtension("DRL_ISCN", "SBO sales credit note im-/exporter for MoviantoNL", typeof(Produmex.Sbo.Logex.MoviantoNL.Extensions.Interfacing.SboSalesCreditNoteInterface), Produmex.Sbo.Logex.Data.BusinessObjects.Definitions.PmxExtensionTypeCodes.IINTERFACING_SBOSALESCREDITNOTE, conn);

					AddUpdateExtension("DRL_IIPY", "SBO Incoming Payment im-/exporter for MoviantoNL", typeof(Produmex.Sbo.Logex.MoviantoNL.Extensions.Interfacing.SboIncomingPaymentInterface), Produmex.Sbo.Logex.Data.BusinessObjects.Definitions.PmxExtensionTypeCodes.IINTERFACING_SBOINCOMINGPAYMENT, conn);

					AddUpdateExtension("DRL_IBP", "SBO Business Partner im-/exporter for MoviantoNL", typeof(Produmex.Sbo.Logex.MoviantoNL.Extensions.Interfacing.SboBusinessPartnerInterface), Produmex.Sbo.Logex.Data.BusinessObjects.Definitions.PmxExtensionTypeCodes.IINTERFACING_SBOBUSINESSPARTNER, conn);


					AddUpdateExtension("DRL_ISN", "Pmx Serial numbers im-/exporter for MoviantoNL", typeof(Produmex.Sbo.Logex.MoviantoNL.Extensions.Interfacing.PmxSerialNumberInterface), Produmex.Sbo.Logex.Data.BusinessObjects.Definitions.PmxExtensionTypeCodes.IINTERFACING_PMXSERIALNUMBERS, conn);

					AddUpdateExtension("DRL_WHST", "Sbo whs transfer im-/exporter for MoviantoNL", typeof(Produmex.Sbo.Logex.MoviantoNL.Extensions.Interfacing.SboWarehouseTransferInterface), Produmex.Sbo.Logex.Data.BusinessObjects.Definitions.PmxExtensionTypeCodes.IINTERFACING_SBOWHSTRANSFER, conn);


					SboUserFieldMDProvider udfProv = new SboUserFieldMDProvider(conn);

					// * UDF's *
					udfProv.AddUpdateUserfield("OITM", new SboColumnDefinitionAttribute("PMX_DR_NAT_CODE", "National Code", SboFieldType.Alpha, 50, SboFieldSubType.None));

					SboColumnDefinitionAttribute boolColumnDef = new SboColumnDefinitionAttribute("PMX_DR_FBSE", "Force Batch Selection?", SboFieldType.Alpha, 1, SboFieldSubType.None);
					boolColumnDef.SboBOColumnConverterType = typeof(SboBooleanConvertor);
					boolColumnDef.DefaultValue = "Y";
					udfProv.AddUpdateUserfield("OCRD", boolColumnDef);

					boolColumnDef = new SboColumnDefinitionAttribute("PMX_DR_MNGD_BP", "Managed BP data", SboFieldType.Alpha, 1, SboFieldSubType.None);
					boolColumnDef.SboBOColumnConverterType = typeof(SboBooleanConvertor);
					boolColumnDef.DefaultValue = "Y";
					udfProv.AddUpdateUserfield("OCRD", boolColumnDef);

					boolColumnDef = new SboColumnDefinitionAttribute("U_PMX_DR_SND_SOC", "Send SalesOrderConfirmation", SboFieldType.Alpha, 1, SboFieldSubType.None);
					boolColumnDef.SboBOColumnConverterType = typeof(SboBooleanConvertor);
					boolColumnDef.DefaultValue = "Y";
					udfProv.AddUpdateUserfield("OCRD", boolColumnDef);

					boolColumnDef = new SboColumnDefinitionAttribute("U_PMX_MOV_ALLOWALL", "Allow batch allocation", SboFieldType.Alpha, 1, SboFieldSubType.None);
					boolColumnDef.SboBOColumnConverterType = typeof(SboBooleanConvertor);
					boolColumnDef.DefaultValue = "N";
					boolColumnDef.IsMandatory = true;
					udfProv.AddUpdateUserfield("OCRD", boolColumnDef);

					udfProv.AddUpdateUserfield("ORDR", new SboColumnDefinitionAttribute("PMX_DR_SAL_ORDR", "Sales order number", SboFieldType.Alpha, 20, SboFieldSubType.None));
					udfProv.AddUpdateUserfield("ORDR", new SboColumnDefinitionAttribute("PMX_DR_IMSC", "Opdrachtgever code", SboFieldType.Alpha, 15, SboFieldSubType.None));
					udfProv.AddUpdateUserfield("ORDR", new SboColumnDefinitionAttribute("PMX_DR_IMSN", "Opdrachtgever naam", SboFieldType.Alpha, 100, SboFieldSubType.None));
					udfProv.AddUpdateUserfield("ORDR", new SboColumnDefinitionAttribute("PMX_DR_OPEN_HOURS", "Opening hours", SboFieldType.Alpha, 100, SboFieldSubType.None));
					udfProv.AddUpdateUserfield("ORDR", new SboColumnDefinitionAttribute("PMX_DR_INV_REMARKS", "Invoice remarks", SboFieldType.Alpha, 100, SboFieldSubType.None));
					udfProv.AddUpdateUserfield("ORDR", new SboColumnDefinitionAttribute("PMX_DR_INV_PAYTERM", "Invoice payment terms", SboFieldType.Alpha, 100, SboFieldSubType.None));

					udfProv.AddUpdateUserfield(PmxSalesOrderTable.NAME, new SboColumnDefinitionAttribute(
						Produmex.Sbo.Logex.MoviantoNL.BusinessObjects.Definitions.Tables.PmxSalesOrderTable.Columns.Name2.NAME,
						Produmex.Sbo.Logex.MoviantoNL.BusinessObjects.Definitions.Tables.PmxSalesOrderTable.Columns.Name2.DESCR,
						Produmex.Sbo.Logex.MoviantoNL.BusinessObjects.Definitions.Tables.PmxSalesOrderTable.Columns.Name2.TYPE,
						Produmex.Sbo.Logex.MoviantoNL.BusinessObjects.Definitions.Tables.PmxSalesOrderTable.Columns.Name2.SIZE,
						Produmex.Sbo.Logex.MoviantoNL.BusinessObjects.Definitions.Tables.PmxSalesOrderTable.Columns.Name2.SUB_TYPE));


					udfProv.AddUpdateUserfield(PmxSalesOrderTable.NAME, new SboColumnDefinitionAttribute(
						Produmex.Sbo.Logex.MoviantoNL.BusinessObjects.Definitions.Tables.PmxSalesOrderTable.Columns.Address2.NAME,
						Produmex.Sbo.Logex.MoviantoNL.BusinessObjects.Definitions.Tables.PmxSalesOrderTable.Columns.Address2.DESCR,
						Produmex.Sbo.Logex.MoviantoNL.BusinessObjects.Definitions.Tables.PmxSalesOrderTable.Columns.Address2.TYPE,
						Produmex.Sbo.Logex.MoviantoNL.BusinessObjects.Definitions.Tables.PmxSalesOrderTable.Columns.Address2.SIZE,
						Produmex.Sbo.Logex.MoviantoNL.BusinessObjects.Definitions.Tables.PmxSalesOrderTable.Columns.Address2.SUB_TYPE));

					udfProv.AddUpdateUserfield(PmxSalesOrderTable.NAME, new SboColumnDefinitionAttribute(
						Produmex.Sbo.Logex.MoviantoNL.BusinessObjects.Definitions.Tables.PmxSalesOrderTable.Columns.ExtraRemarks.NAME,
						Produmex.Sbo.Logex.MoviantoNL.BusinessObjects.Definitions.Tables.PmxSalesOrderTable.Columns.ExtraRemarks.DESCR,
						Produmex.Sbo.Logex.MoviantoNL.BusinessObjects.Definitions.Tables.PmxSalesOrderTable.Columns.ExtraRemarks.TYPE,
						Produmex.Sbo.Logex.MoviantoNL.BusinessObjects.Definitions.Tables.PmxSalesOrderTable.Columns.ExtraRemarks.SIZE,
						Produmex.Sbo.Logex.MoviantoNL.BusinessObjects.Definitions.Tables.PmxSalesOrderTable.Columns.ExtraRemarks.SUB_TYPE));

					udfProv.AddUpdateUserfield(PmxSalesOrderTable.NAME, new SboColumnDefinitionAttribute(
						Produmex.Sbo.Logex.MoviantoNL.BusinessObjects.Definitions.Tables.PmxSalesOrderTable.Columns.CustomerPO.NAME,
						Produmex.Sbo.Logex.MoviantoNL.BusinessObjects.Definitions.Tables.PmxSalesOrderTable.Columns.CustomerPO.DESCR,
						Produmex.Sbo.Logex.MoviantoNL.BusinessObjects.Definitions.Tables.PmxSalesOrderTable.Columns.CustomerPO.TYPE,
						Produmex.Sbo.Logex.MoviantoNL.BusinessObjects.Definitions.Tables.PmxSalesOrderTable.Columns.CustomerPO.SIZE,
						Produmex.Sbo.Logex.MoviantoNL.BusinessObjects.Definitions.Tables.PmxSalesOrderTable.Columns.CustomerPO.SUB_TYPE));


					udfProv.AddUpdateUserfield(PmxPurchaseOrderLineTable.NAME, new SboColumnDefinitionAttribute(
						Produmex.Sbo.Logex.MoviantoNL.BusinessObjects.Definitions.Tables.PmxPurchaseOrderLineTable.Columns.SerialNumber.NAME,
						Produmex.Sbo.Logex.MoviantoNL.BusinessObjects.Definitions.Tables.PmxPurchaseOrderLineTable.Columns.SerialNumber.DESCR,
						Produmex.Sbo.Logex.MoviantoNL.BusinessObjects.Definitions.Tables.PmxPurchaseOrderLineTable.Columns.SerialNumber.TYPE,
						Produmex.Sbo.Logex.MoviantoNL.BusinessObjects.Definitions.Tables.PmxPurchaseOrderLineTable.Columns.SerialNumber.SIZE,
						Produmex.Sbo.Logex.MoviantoNL.BusinessObjects.Definitions.Tables.PmxPurchaseOrderLineTable.Columns.SerialNumber.SUB_TYPE));




					boolColumnDef = new SboColumnDefinitionAttribute("PMX_DR_INV_REQUIR", "Invoice required", SboFieldType.Alpha, 1, SboFieldSubType.None);
					boolColumnDef.SboBOColumnConverterType = typeof(SboBooleanConvertor);
					boolColumnDef.DefaultValue = "Y";
					udfProv.AddUpdateUserfield("ORDR", boolColumnDef);

					udfProv.AddUpdateUserfield("RDR1", new SboColumnDefinitionAttribute("PMX_DR_SAL_LINENUM", "Sales order line number", SboFieldType.Numeric));
					udfProv.AddUpdateUserfield("RDR1", new SboColumnDefinitionAttribute("PMX_DR_BAT_LINENUM", "Batch line number", SboFieldType.Numeric));
					udfProv.AddUpdateUserfield("RDR1", new SboColumnDefinitionAttribute("PMX_DR_COMMENTS", "Comments line", SboFieldType.Memo));

					udfProv.AddUpdateUserfield("ODLN", new SboColumnDefinitionAttribute("PMX_DR_IMSC", "Opdrachtgever code", SboFieldType.Alpha, 15, SboFieldSubType.None));
					udfProv.AddUpdateUserfield("ODLN", new SboColumnDefinitionAttribute("PMX_DR_IMSN", "Opdrachtgever naam", SboFieldType.Alpha, 100, SboFieldSubType.None));
					udfProv.AddUpdateUserfield("ODLN", new SboColumnDefinitionAttribute("PMX_DR_COLLI", "Number of colli", SboFieldType.Numeric));
					udfProv.AddUpdateUserfield("ODLN", new SboColumnDefinitionAttribute("PMX_DR_LOGCAR", "Logistic carrier code", SboFieldType.Alpha, 20, SboFieldSubType.None));


					udfProv.AddUpdateUserfield(PmxSalesOrderTable.NAME, new SboColumnDefinitionAttribute(
						Produmex.Sbo.Logex.MoviantoNL.BusinessObjects.Definitions.Tables.PmxSalesOrderTable.Columns.ServiceLevel.NAME,
						Produmex.Sbo.Logex.MoviantoNL.BusinessObjects.Definitions.Tables.PmxSalesOrderTable.Columns.ServiceLevel.DESCR,
						Produmex.Sbo.Logex.MoviantoNL.BusinessObjects.Definitions.Tables.PmxSalesOrderTable.Columns.ServiceLevel.TYPE,
						Produmex.Sbo.Logex.MoviantoNL.BusinessObjects.Definitions.Tables.PmxSalesOrderTable.Columns.ServiceLevel.SIZE,
						Produmex.Sbo.Logex.MoviantoNL.BusinessObjects.Definitions.Tables.PmxSalesOrderTable.Columns.ServiceLevel.SUB_TYPE));



					// Not by Produmex
					//udfProv.AddUpdateUserfield( "ORDR", new SboColumnDefinitionAttribute( "CUSTOMER_PO", "Customer PO", SboFieldType.Alpha, 45, SboFieldSubType.None ) );
					//udfProv.AddUpdateUserfield( "ORDR", new SboColumnDefinitionAttribute( "CUSTOMER_PO", "Customer PO", SboFieldType.Alpha, 45, SboFieldSubType.None ) );

					//udfProv.AddUpdateUserfield(PmxItemTable.NAME, new SboColumnDefinitionAttribute(
					//    Produmex.Sbo.Logex.MoviantoNL.BusinessObjects.Definitions.Tables.PmxItemTable.Columns.Categorie.NAME,
					//    Produmex.Sbo.Logex.MoviantoNL.BusinessObjects.Definitions.Tables.PmxItemTable.Columns.Categorie.DESCR,
					//    Produmex.Sbo.Logex.MoviantoNL.BusinessObjects.Definitions.Tables.PmxItemTable.Columns.Categorie.TYPE,
					//    Produmex.Sbo.Logex.MoviantoNL.BusinessObjects.Definitions.Tables.PmxItemTable.Columns.Categorie.SIZE,
					//    Produmex.Sbo.Logex.MoviantoNL.BusinessObjects.Definitions.Tables.PmxItemTable.Columns.Categorie.SUB_TYPE));




					udfProv.AddUpdateUserfield("OBTN", new SboColumnDefinitionAttribute("PMX_STATUS", "PMX Status", SboFieldType.Alpha, 80, SboFieldSubType.None));


					udfProv.AddUpdateUserfield(PmxSalesOrderTable.NAME, new SboColumnDefinitionAttribute(
	Produmex.Sbo.Logex.MoviantoNL.BusinessObjects.Definitions.Tables.PmxSalesOrderTable.Columns.TextField1.NAME,
	Produmex.Sbo.Logex.MoviantoNL.BusinessObjects.Definitions.Tables.PmxSalesOrderTable.Columns.TextField1.DESCR,
	Produmex.Sbo.Logex.MoviantoNL.BusinessObjects.Definitions.Tables.PmxSalesOrderTable.Columns.TextField1.TYPE,
	Produmex.Sbo.Logex.MoviantoNL.BusinessObjects.Definitions.Tables.PmxSalesOrderTable.Columns.TextField1.SIZE,
	Produmex.Sbo.Logex.MoviantoNL.BusinessObjects.Definitions.Tables.PmxSalesOrderTable.Columns.TextField1.SUB_TYPE));

					udfProv.AddUpdateUserfield(PmxSalesOrderTable.NAME, new SboColumnDefinitionAttribute(
Produmex.Sbo.Logex.MoviantoNL.BusinessObjects.Definitions.Tables.PmxSalesOrderTable.Columns.TextField2.NAME,
Produmex.Sbo.Logex.MoviantoNL.BusinessObjects.Definitions.Tables.PmxSalesOrderTable.Columns.TextField2.DESCR,
Produmex.Sbo.Logex.MoviantoNL.BusinessObjects.Definitions.Tables.PmxSalesOrderTable.Columns.TextField2.TYPE,
Produmex.Sbo.Logex.MoviantoNL.BusinessObjects.Definitions.Tables.PmxSalesOrderTable.Columns.TextField2.SIZE,
Produmex.Sbo.Logex.MoviantoNL.BusinessObjects.Definitions.Tables.PmxSalesOrderTable.Columns.TextField2.SUB_TYPE));

					udfProv.AddUpdateUserfield(PmxSalesOrderTable.NAME, new SboColumnDefinitionAttribute(
Produmex.Sbo.Logex.MoviantoNL.BusinessObjects.Definitions.Tables.PmxSalesOrderTable.Columns.TextField3.NAME,
Produmex.Sbo.Logex.MoviantoNL.BusinessObjects.Definitions.Tables.PmxSalesOrderTable.Columns.TextField3.DESCR,
Produmex.Sbo.Logex.MoviantoNL.BusinessObjects.Definitions.Tables.PmxSalesOrderTable.Columns.TextField3.TYPE,
Produmex.Sbo.Logex.MoviantoNL.BusinessObjects.Definitions.Tables.PmxSalesOrderTable.Columns.TextField3.SIZE,
Produmex.Sbo.Logex.MoviantoNL.BusinessObjects.Definitions.Tables.PmxSalesOrderTable.Columns.TextField3.SUB_TYPE));

					udfProv.AddUpdateUserfield(PmxSalesOrderTable.NAME, new SboColumnDefinitionAttribute(
Produmex.Sbo.Logex.MoviantoNL.BusinessObjects.Definitions.Tables.PmxSalesOrderTable.Columns.TextField4.NAME,
Produmex.Sbo.Logex.MoviantoNL.BusinessObjects.Definitions.Tables.PmxSalesOrderTable.Columns.TextField4.DESCR,
Produmex.Sbo.Logex.MoviantoNL.BusinessObjects.Definitions.Tables.PmxSalesOrderTable.Columns.TextField4.TYPE,
Produmex.Sbo.Logex.MoviantoNL.BusinessObjects.Definitions.Tables.PmxSalesOrderTable.Columns.TextField4.SIZE,
Produmex.Sbo.Logex.MoviantoNL.BusinessObjects.Definitions.Tables.PmxSalesOrderTable.Columns.TextField4.SUB_TYPE));

					udfProv.AddUpdateUserfield(PmxSalesOrderTable.NAME, new SboColumnDefinitionAttribute(
Produmex.Sbo.Logex.MoviantoNL.BusinessObjects.Definitions.Tables.PmxSalesOrderTable.Columns.TextField5.NAME,
Produmex.Sbo.Logex.MoviantoNL.BusinessObjects.Definitions.Tables.PmxSalesOrderTable.Columns.TextField5.DESCR,
Produmex.Sbo.Logex.MoviantoNL.BusinessObjects.Definitions.Tables.PmxSalesOrderTable.Columns.TextField5.TYPE,
Produmex.Sbo.Logex.MoviantoNL.BusinessObjects.Definitions.Tables.PmxSalesOrderTable.Columns.TextField5.SIZE,
Produmex.Sbo.Logex.MoviantoNL.BusinessObjects.Definitions.Tables.PmxSalesOrderTable.Columns.TextField5.SUB_TYPE));

					udfProv.AddUpdateUserfield(PmxSalesOrderTable.NAME, new SboColumnDefinitionAttribute(
Produmex.Sbo.Logex.MoviantoNL.BusinessObjects.Definitions.Tables.PmxSalesOrderTable.Columns.TextField6.NAME,
Produmex.Sbo.Logex.MoviantoNL.BusinessObjects.Definitions.Tables.PmxSalesOrderTable.Columns.TextField6.DESCR,
Produmex.Sbo.Logex.MoviantoNL.BusinessObjects.Definitions.Tables.PmxSalesOrderTable.Columns.TextField6.TYPE,
Produmex.Sbo.Logex.MoviantoNL.BusinessObjects.Definitions.Tables.PmxSalesOrderTable.Columns.TextField6.SIZE,
Produmex.Sbo.Logex.MoviantoNL.BusinessObjects.Definitions.Tables.PmxSalesOrderTable.Columns.TextField6.SUB_TYPE));

					udfProv.AddUpdateUserfield(PmxSalesOrderTable.NAME, new SboColumnDefinitionAttribute(
Produmex.Sbo.Logex.MoviantoNL.BusinessObjects.Definitions.Tables.PmxSalesOrderTable.Columns.TextField7.NAME,
Produmex.Sbo.Logex.MoviantoNL.BusinessObjects.Definitions.Tables.PmxSalesOrderTable.Columns.TextField7.DESCR,
Produmex.Sbo.Logex.MoviantoNL.BusinessObjects.Definitions.Tables.PmxSalesOrderTable.Columns.TextField7.TYPE,
Produmex.Sbo.Logex.MoviantoNL.BusinessObjects.Definitions.Tables.PmxSalesOrderTable.Columns.TextField7.SIZE,
Produmex.Sbo.Logex.MoviantoNL.BusinessObjects.Definitions.Tables.PmxSalesOrderTable.Columns.TextField7.SUB_TYPE));

					udfProv.AddUpdateUserfield(PmxSalesOrderTable.NAME, new SboColumnDefinitionAttribute(
Produmex.Sbo.Logex.MoviantoNL.BusinessObjects.Definitions.Tables.PmxSalesOrderTable.Columns.TextField8.NAME,
Produmex.Sbo.Logex.MoviantoNL.BusinessObjects.Definitions.Tables.PmxSalesOrderTable.Columns.TextField8.DESCR,
Produmex.Sbo.Logex.MoviantoNL.BusinessObjects.Definitions.Tables.PmxSalesOrderTable.Columns.TextField8.TYPE,
Produmex.Sbo.Logex.MoviantoNL.BusinessObjects.Definitions.Tables.PmxSalesOrderTable.Columns.TextField8.SIZE,
Produmex.Sbo.Logex.MoviantoNL.BusinessObjects.Definitions.Tables.PmxSalesOrderTable.Columns.TextField8.SUB_TYPE));

					udfProv.AddUpdateUserfield(PmxSalesOrderTable.NAME, new SboColumnDefinitionAttribute(
Produmex.Sbo.Logex.MoviantoNL.BusinessObjects.Definitions.Tables.PmxSalesOrderTable.Columns.TextField9.NAME,
Produmex.Sbo.Logex.MoviantoNL.BusinessObjects.Definitions.Tables.PmxSalesOrderTable.Columns.TextField9.DESCR,
Produmex.Sbo.Logex.MoviantoNL.BusinessObjects.Definitions.Tables.PmxSalesOrderTable.Columns.TextField9.TYPE,
Produmex.Sbo.Logex.MoviantoNL.BusinessObjects.Definitions.Tables.PmxSalesOrderTable.Columns.TextField9.SIZE,
Produmex.Sbo.Logex.MoviantoNL.BusinessObjects.Definitions.Tables.PmxSalesOrderTable.Columns.TextField9.SUB_TYPE));


					udfProv.AddUpdateUserfield(PmxSalesOrderTable.NAME, new SboColumnDefinitionAttribute(
	Produmex.Sbo.Logex.MoviantoNL.BusinessObjects.Definitions.Tables.PmxSalesOrderTable.Columns.TextField10.NAME,
	Produmex.Sbo.Logex.MoviantoNL.BusinessObjects.Definitions.Tables.PmxSalesOrderTable.Columns.TextField10.DESCR,
	Produmex.Sbo.Logex.MoviantoNL.BusinessObjects.Definitions.Tables.PmxSalesOrderTable.Columns.TextField10.TYPE,
	Produmex.Sbo.Logex.MoviantoNL.BusinessObjects.Definitions.Tables.PmxSalesOrderTable.Columns.TextField10.SIZE,
	Produmex.Sbo.Logex.MoviantoNL.BusinessObjects.Definitions.Tables.PmxSalesOrderTable.Columns.TextField10.SUB_TYPE));


					udfProv.AddUpdateUserfield(PmxBusinessPartnerTable.NAME, new SboColumnDefinitionAttribute(
Produmex.Sbo.Logex.MoviantoNL.BusinessObjects.Definitions.Tables.PmxBusinessPartnerDRTable.Columns.OpdrachtgeverCode.NAME,
Produmex.Sbo.Logex.MoviantoNL.BusinessObjects.Definitions.Tables.PmxBusinessPartnerDRTable.Columns.OpdrachtgeverCode.DESCR,
Produmex.Sbo.Logex.MoviantoNL.BusinessObjects.Definitions.Tables.PmxBusinessPartnerDRTable.Columns.OpdrachtgeverCode.TYPE,
Produmex.Sbo.Logex.MoviantoNL.BusinessObjects.Definitions.Tables.PmxBusinessPartnerDRTable.Columns.OpdrachtgeverCode.SIZE,
Produmex.Sbo.Logex.MoviantoNL.BusinessObjects.Definitions.Tables.PmxBusinessPartnerDRTable.Columns.OpdrachtgeverCode.SUB_TYPE));


					udfProv.AddUpdateUserfield(PmxSalesOrderTable.NAME, new SboColumnDefinitionAttribute(
Produmex.Sbo.Logex.MoviantoNL.BusinessObjects.Definitions.Tables.PmxSalesOrderTable.Columns.TrackingNumberMovianto.NAME,
Produmex.Sbo.Logex.MoviantoNL.BusinessObjects.Definitions.Tables.PmxSalesOrderTable.Columns.TrackingNumberMovianto.DESCR,
Produmex.Sbo.Logex.MoviantoNL.BusinessObjects.Definitions.Tables.PmxSalesOrderTable.Columns.TrackingNumberMovianto.TYPE,
Produmex.Sbo.Logex.MoviantoNL.BusinessObjects.Definitions.Tables.PmxSalesOrderTable.Columns.TrackingNumberMovianto.SIZE,
Produmex.Sbo.Logex.MoviantoNL.BusinessObjects.Definitions.Tables.PmxSalesOrderTable.Columns.TrackingNumberMovianto.SUB_TYPE));


				
					SboColumnDefinitionAttribute bpSendDSPFile = new SboColumnDefinitionAttribute(
						Produmex.Sbo.Logex.MoviantoNL.BusinessObjects.Definitions.Tables.PmxBusinessPartnerDRTable.Columns.SendDSPFile.NAME,
						Produmex.Sbo.Logex.MoviantoNL.BusinessObjects.Definitions.Tables.PmxBusinessPartnerDRTable.Columns.SendDSPFile.DESCR,
						Produmex.Sbo.Logex.MoviantoNL.BusinessObjects.Definitions.Tables.PmxBusinessPartnerDRTable.Columns.SendDSPFile.TYPE,
						Produmex.Sbo.Logex.MoviantoNL.BusinessObjects.Definitions.Tables.PmxBusinessPartnerDRTable.Columns.SendDSPFile.SIZE,
						Produmex.Sbo.Logex.MoviantoNL.BusinessObjects.Definitions.Tables.PmxBusinessPartnerDRTable.Columns.SendDSPFile.SUB_TYPE
						);

					bpSendDSPFile.DefaultValue = PmxMovSendDSPCodes.AFTER_DELIVERY_CREATED;
					bpSendDSPFile.IsMandatory = true;
					bpSendDSPFile.ValidColumnValues = new SboValidValue[2];
					bpSendDSPFile.ValidColumnValues[0].Value = PmxMovSendDSPCodes.AFTER_DELIVERY_CREATED;
					bpSendDSPFile.ValidColumnValues[0].Description = "Na levering";
					bpSendDSPFile.ValidColumnValues[1].Value = PmxMovSendDSPCodes.AFTER_PACKING;
					bpSendDSPFile.ValidColumnValues[1].Description = "Na verpakking";
					
					udfProv.AddUpdateUserfield(PmxBusinessPartnerTable.NAME, bpSendDSPFile);


					PmxDbVersionUpdaterProvider updateProv = new PmxDbVersionUpdaterProvider(conn);

					//Tracking number
					updateProv.AddUpdateUserDefinedTable(typeof(PmxTrackingNumberMOV));
					updateProv.AddUpdateUserDefinedObject(typeof(PmxTrackingNumberMOV));

					//Carrier
					updateProv.AddUpdateUserDefinedTable(typeof(PmxCarrierMOV));
					updateProv.AddUpdateUserDefinedObject(typeof(PmxCarrierMOV));


					/*
					PmxDbVersionUpdaterProvider updProv = new PmxDbVersionUpdaterProvider( conn );

					SboUserQueryCategoryProvider uqcProvider = new SboUserQueryCategoryProvider( conn );
					int categoryCode;
					using ( SboUserQueryCategory category = uqcProvider.GetUserQueryCategoryByName( PmxUserQueryCategoryName.PMX_ADDON ) )
					{
						categoryCode = category.Code;
					}

					string query = @"SELECT CONVERT( VARCHAR, CONVERT( REAL, ISNULL( SUM( CASE PMX_INVT.QualityStatusCode WHEN 'RELEASED' THEN PMX_INVT.Quantity ELSE NULL END ), 0 ) ) ) + ' released '
	+ CONVERT( VARCHAR, CONVERT( REAL, ISNULL( SUM( CASE PMX_INVT.QualityStatusCode WHEN 'RELEASED' THEN NULL ELSE PMX_INVT.Quantity END ), 0 ) ) ) + ' other'
FROM PMX_ITRI
INNER JOIN PMX_INVT ON PMX_INVT.ItemTransactionalInfoKey = PMX_ITRI.InternalKey
WHERE PMX_INVT.ItemCode = $[SBDR.ItemCode]
AND PMX_ITRI.BatchNumber = $[OBTN.DistNumber]";
					int qryId = updProv.AddUpdateUserQuery( "PMX_BATCH_QTY_STATUS", categoryCode, query );

					updProv.AddUpdateFormattedSearch( "42", "4", "U_PMX_STATUS", qryId, null, false );
					updProv.AddUpdateFormattedSearch( "42", "5", "U_PMX_STATUS", qryId, null, false );
					 * */
				}

                //Complete transaction
                scope.Complete();
            }


            //using (TransactionScope scope = PmxDbConnection.GetNewTransactionScope())
            //{
            //    using (PmxDbConnectionSql dbConn = new PmxDbConnectionSql(CONNECTION_STRING))
            //    {
            //        dbConn.Open(); //Open connection to SAP
            //        Console.WriteLine("Connection is open to database");
            //        Console.WriteLine("Add workflows");

            //        if (dbConn.Database.StartsWith("MOVIANTO_"))
            //        {
            //            //This is for NL
            //            AddUpdateWorkflowScript(PmxWorkflowExecutionTypes.HOOK_FLOW, "AfterPickListPackedHookScript",
            //               SCRIPT_ROOT + @"\WorkflowScript_AfterPickListPackedHookScriptNL\WorkflowScript_AfterPickListPackedHookScript.cs", dbConn);
            //            AddUpdateWorkflowScript(PmxWorkflowExecutionTypes.HOOK_FLOW, "SalesDeliveryCreatedHookScript",
            //               SCRIPT_ROOT + @"\WorkflowScript_SalesDeliveryCreatedHookScriptNL\WorkflowScript_SalesDeliveryCreatedHookScript.cs", dbConn);
            //            AddUpdateWorkflowScript(PmxWorkflowExecutionTypes.HOOK_FLOW, "AfterItemPickedHookScript",
            //               SCRIPT_ROOT + @"\WorkflowScript_AfterItemPickedHookScript\WorkflowScript_AfterItemPickedHookScript.cs", dbConn);
            //        }
            //        else
            //        {

            //            //AddUpdateWorkflowScript(PmxWorkflowExecutionTypes.HOOK_FLOW, "BeforeAutomaticShippingHookScript",
            //            //    SCRIPT_ROOT + @"\WorkflowScript_BeforeAutomaticShippingHookScript\WorkflowScript_BeforeAutomaticShippingHookScript.cs", dbConn);
            //            AddUpdateWorkflowScript(PmxWorkflowExecutionTypes.HOOK_FLOW, "AfterPickListPackedHookScript",
            //               SCRIPT_ROOT + @"\WorkflowScript_AfterPickListPackedHookScript\WorkflowScript_AfterPickListPackedHookScript.cs", dbConn);
            //            AddUpdateWorkflowScript(PmxWorkflowExecutionTypes.HOOK_FLOW, "SalesDeliveryCreatedHookScript",
            //               SCRIPT_ROOT + @"\WorkflowScript_SalesDeliveryCreatedHookScript\WorkflowScript_SalesDeliveryCreatedHookScript.cs", dbConn);
            //            AddUpdateWorkflowScript(PmxWorkflowExecutionTypes.HOOK_FLOW, "AfterItemPickedHookScript",
            //               SCRIPT_ROOT + @"\WorkflowScript_AfterItemPickedHookScript\WorkflowScript_AfterItemPickedHookScript.cs", dbConn);
            //        }
            //    }

            //    //Complete transaction
            //    scope.Complete();
            //    Console.WriteLine("Done ...");
            //}

            using (TransactionScope scope = PmxDbConnection.GetNewTransactionScope())
            {
                using (PmxDbConnectionSql dbConn = new PmxDbConnectionSql(CONNECTION_STRING))
                {
                    dbConn.Open(); //Open connection to SAP       
                    Console.WriteLine("Add views/extend tables");

                    // RunViewSqlScript("PMX_MOV_BATCH_ALLOCATION.sql", dbConn);   
                    RunTableSqlScript("PMX_INLD.sql", dbConn);
                    RunTableSqlScript("PMX_MOV_PLCD.sql", dbConn);
                    RunTableSqlScript("PMX_MOV_GSSC.sql", dbConn);
                    RunTableSqlScript("PMX_LUID.sql", dbConn);
                    //RunViewSqlScript("PMX_MOV_PACKED_PICKLISTS.sql", dbConn);

					RunViewSqlScript("PMX_MOV_ALTERNATE_PACKING.sql", dbConn);
                }

                //Complete transaction
                scope.Complete();
                Console.WriteLine("Done ...");
            }
        }


        /// <summary>
        /// Runs the view SQL script.
        /// </summary>
        /// <param name="viewScript">The view script.</param>
        /// <param name="conn">The conn.</param>
        private static void RunViewSqlScript(string viewScript, PmxDbConnection conn)
        {
            string content = ResourceHelper.ReadResourceContentAsString(Assembly.GetAssembly(typeof(Produmex.Sbo.Logex.MoviantoNL.SboCommands)), "Produmex.Sbo.Logex.MoviantoNL.Scripts.Views." + viewScript);
            SboRecordsetHelper.RunSqlScript(s_log, content, conn);
        }

        /// <summary>
        /// Runs the table SQL script.
        /// </summary>
        /// <param name="tableScript">The table script.</param>
        /// <param name="conn">The conn.</param>
        private static void RunTableSqlScript(string tableScript, PmxDbConnection conn)
        {
            string content = ResourceHelper.ReadResourceContentAsString(Assembly.GetAssembly(typeof(Produmex.Sbo.Logex.MoviantoNL.SboCommands)), "Produmex.Sbo.Logex.MoviantoNL.Scripts.Tables." + tableScript);
            SboRecordsetHelper.RunSqlScript(s_log, content, conn);
        }


        /// <summary>
        /// Add/Update script workflow
        /// </summary>
        /// <param name="executionType">Type of the execution.</param>
        /// <param name="name">The name of the flow.</param>
        /// <param name="sourceFilePath">Name of the file.</param>
        /// <param name="sqlConn">The SQL conn.</param>
        private static void AddUpdateWorkflowScript(string executionType, string name, string sourceFilePath, PmxDbConnectionSql sqlConn)
        {
            Console.WriteLine("Path: " + sourceFilePath);
            PmxWorkflowProvider wfProvider = new PmxWorkflowProvider(sqlConn);
            PmxWorkflow workflow = wfProvider.GetWorkflowByName(name);
            PmxWorkflowScriptProvider wfscProvider = new PmxWorkflowScriptProvider(sqlConn);
            PmxWorkflowScript bo = null;
            if (workflow == null)
            {
                //add the workflow
                bo = wfscProvider.GetNewBO();
                bo.Name = name;
                wfscProvider.AddBO(bo);
            }
            else
            {
                if (workflow.ObjType == Produmex.Sbo.Logex.Data.BusinessObjects.Definitions.PmxObjectTypes.PmxWorkflowScript)
                {
                    bo = wfscProvider.GetBO(workflow.InternalKey);

                }
            }

            if (bo != null)
            {
                bo.ExecutionType = executionType;

                wfscProvider.UpdateSourceFromFileAndCompile(bo, sourceFilePath, sqlConn);
            }



        }

        /// <summary>
        /// Add/Update <see cref="PmxExtensionParameter"/>
        /// </summary>
        /// <param name="code">The code of the extension parameter.</param>
        /// <param name="name">The name of the extension parameter.</param>
        /// <param name="extensionCode">The extension code.</param>
        /// <param name="convertorCode">The convertor code.</param>
        /// <param name="defaultValue">The default value.</param>
        /// <param name="generalParameterCode">The general parameter code.</param>
        /// <param name="conn">The SBO connection</param>
        public static void AddUpdateExtensionParameter(string code, string name, string extensionCode, string convertorCode, string defaultValue, string generalParameterCode, SboConnection conn)
        {
            PmxExtensionParameterProvider prov = new PmxExtensionParameterProvider(conn);
            PmxExtensionParameter extParam = null;
            try
            {
                bool newBO = false;
                extParam = prov.GetBO(code);
                if (extParam == null)
                {
                    newBO = true;
                    extParam = prov.GetNewBO();
                    extParam.Code = code;
                }
                extParam.Name = name;
                extParam.ExtensionCode = extensionCode;
                extParam.ConvertorCode = convertorCode;
                extParam.DefaultValue = defaultValue;
                extParam.GeneralParameterCode = generalParameterCode;
                if (newBO)
                {
                    prov.AddBO(extParam);
                }
                else
                {
                    prov.UpdateBO(extParam, false, false);
                }
            }
            finally
            {
                if (extParam != null) extParam.Dispose();
            }
        }

        /// <summary>
        /// Add/Update <see cref="PmxExtension"/>
        /// </summary>
        /// <param name="code">The code of the extension.</param>
        /// <param name="name">The name of the extension.</param>
        /// <param name="type">The type of the extension.</param>
        /// <param name="extensionTypeCode">The extension type code.</param>
        /// <param name="conn">The SBO connection</param>
        private static void AddUpdateExtension(string code, string name, Type type, string extensionTypeCode, SboConnection conn)
        {
            PmxExtensionProvider prov = new PmxExtensionProvider(conn);
            PmxExtension extension = null;
            try
            {
                bool newBO = false;
                extension = prov.GetBO(code);
                if (extension == null)
                {
                    newBO = true;
                    extension = prov.GetNewBO();
                    extension.Code = code;
                }
                extension.Name = name;
                extension.ExtensionTypeCode = extensionTypeCode;
                extension.Type = ReflectionHelper.GetTypeAndAssemblyName(type);
                if (newBO)
                {
                    prov.AddBO(extension);
                }
                else
                {
                    prov.UpdateBO(extension, false, false);
                }
            }
            finally
            {
                if (extension != null) extension.Dispose();
            }
        }


    }
}
