IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[PMX_SP_DIRK_REAS_DeliveryDocumentSalesOrder]') AND type in (N'P', N'PC'))
DROP PROCEDURE [dbo].[PMX_SP_DIRK_REAS_DeliveryDocumentSalesOrder]
GO

-- =============================================
-- Author:		Produmex
-- Create date: 
-- Description:	Sales Delivery Document Dirk Raes
-- =============================================
CREATE PROCEDURE [dbo].[PMX_SP_DIRK_REAS_DeliveryDocumentSalesOrder] 
	-- Parameters for the stored procedure
	@salesDeliveryNoteDocEntry int = 0
AS
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;

SELECT     TOP (100) PERCENT dbo.ODLN.DocEntry, dbo.ODLN.CardName, dbo.ODLN.Address2 AS Address, ISNULL(dbo.RDR1.Quantity, 0) AS OrderQuantity, 
                      dbo.ORDR.DocNum, dbo.PMX_ITRI.BestBeforeDate, dbo.ODLN.DocDate, dbo.ODLN.DocNum AS DeliveryDocNum, 
                      dbo.PMX_ITRI.BatchNumber AS BatchNum, SUM(dbo.PMX_INVD.Quantity) * - 1 AS DeliveredQuantity, dbo.PMX_INVD.ItemCode, 
                      dbo.PMX_INVD.ItemName AS Dscription, dbo.ORDR.U_CUSTOMER_PO AS CustomerPO, dbo.ORDR.U_PMX_DR_SAL_ORDR AS DR_SalesOrder, 
                      dbo.ORDR.U_PMX_DR_IMSC AS InitiatorCode, dbo.ORDR.U_PMX_DR_IMSN AS InitiatorName, dbo.OITM.U_PMX_DR_NAT_CODE AS NationalCode, 
                      dbo.DLN1.U_PMX_DR_SAL_LINENUM AS [DR-SalesOrderLineNumber], CAST(dbo.DLN1.U_PMX_DR_COMMENTS AS Nvarchar(245)) 
                      AS DR_CommentsLine, dbo.ORDR.Comments, dbo.ODLN.DocTime, dbo.ODLN.CardCode, dbo.DLN1.unitMsr, dbo.ODLN.Weight, dbo.DLN1.PackQty, 
                      dbo.OWGT.UnitDisply AS UnitWeight,
					  (SELECT     COUNT(DISTINCT dbo.PMX_MVLI.DestLogUnitIdentKey) AS NrOfColli
					  FROM         dbo.PMX_MVLI INNER JOIN
										  dbo.PMX_DLPL ON dbo.PMX_MVLI.DocEntry = dbo.PMX_DLPL.MoveLineDocEntry AND 
										  dbo.PMX_MVLI.LineNum = dbo.PMX_DLPL.MoveLineLineNum
					  WHERE     (dbo.PMX_DLPL.SalesDeliveryNoteLineDocEntry = @salesDeliveryNoteDocEntry)) AS NrOfColli
FROM         dbo.DLN1 INNER JOIN
                      dbo.ODLN ON dbo.DLN1.DocEntry = dbo.ODLN.DocEntry INNER JOIN
                      dbo.PMX_INVD ON dbo.DLN1.DocEntry = dbo.PMX_INVD.DocEntry AND dbo.ODLN.ObjType = dbo.PMX_INVD.TransType AND 
                      dbo.DLN1.LineNum = dbo.PMX_INVD.DocLineNum INNER JOIN
                      dbo.PMX_LUID ON dbo.PMX_INVD.LogUnitIdentKey = dbo.PMX_LUID.InternalKey INNER JOIN
                      dbo.OITM ON dbo.DLN1.ItemCode = dbo.OITM.ItemCode INNER JOIN
                      dbo.OWGT ON dbo.ODLN.WeightUnit = dbo.OWGT.UnitCode LEFT OUTER JOIN
                      dbo.ORDR INNER JOIN
                      dbo.RDR1 ON dbo.ORDR.DocEntry = dbo.RDR1.DocEntry ON dbo.DLN1.BaseEntry = dbo.RDR1.DocEntry AND 
                      dbo.DLN1.BaseLine = dbo.RDR1.LineNum AND dbo.DLN1.BaseType = dbo.ORDR.ObjType LEFT OUTER JOIN
                      dbo.PMX_ITRI ON dbo.PMX_ITRI.InternalKey = dbo.PMX_INVD.ItemTransactionalInfoKey
WHERE     (dbo.ODLN.DocEntry = @salesDeliveryNoteDocEntry)
GROUP BY dbo.ODLN.DocEntry, dbo.ORDR.DocNum, dbo.PMX_ITRI.BestBeforeDate, dbo.ODLN.CardName, dbo.ODLN.Address2, dbo.ODLN.DocDate, 
                      dbo.ODLN.DocNum, dbo.RDR1.Quantity, dbo.PMX_ITRI.BatchNumber, dbo.PMX_INVD.ItemCode, dbo.PMX_INVD.ItemName, 
                      dbo.ORDR.U_CUSTOMER_PO, dbo.ORDR.U_PMX_DR_SAL_ORDR, dbo.ORDR.U_PMX_DR_IMSC, dbo.ORDR.U_PMX_DR_IMSN, 
                      dbo.OITM.U_PMX_DR_NAT_CODE, dbo.DLN1.U_PMX_DR_SAL_LINENUM, CAST(dbo.DLN1.U_PMX_DR_COMMENTS AS Nvarchar(245)), 
                      dbo.ORDR.Comments, dbo.ODLN.DocTime, dbo.ODLN.CardCode, dbo.DLN1.unitMsr, dbo.DLN1.PackQty, dbo.ODLN.Weight, dbo.DLN1.PackQty, 
                      dbo.OWGT.UnitDisply
END