ALTER PROCEDURE [dbo].[PMX_SP_MoviantoColliPackageLabel_V2]
	-- Add the parameters for the stored procedure here
	@PickListDocEntry int = 0,
	@SalesOrderDocEntry int = 0
AS
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;

    -- Insert statements for procedure here
	select PMX_MOV_PLCD.InternalKey, PMX_MOV_PLCD.PickListDocEntry, PMX_MOV_PLCD.SalesOrderDocEntry,convert(date,PMX_MOV_PLCD.CreateDateTime,106) AS CreateDate, PMX_MOV_PLCD.ColliID, PMX_MOV_PLCD.Carrier,
	PMX_MOV_PLCD.Width, PMX_MOV_PLCD.Length, PMX_MOV_PLCD.Height, PMX_MOV_PLCD.Weight, PMX_MOV_PLCD.PalletID ,
	ORDR.CardName,
	RDR12.StreetS,
	RDR12.CityS,
	RDR12.ZipCodeS,
	RDR12.CountryS,
	PMX_MOV_PLCD.AWBNr,
	ORDR.U_PMX_MOV_TXT01,
	ORDR.U_PMX_MOV_TXT02,
	ORDR.U_PMX_MOV_TXT03,
	ORDR.U_PMX_MOV_TXT04,
	ORDR.U_PMX_MOV_TXT06,
	ORDR.U_PMX_MOV_TXT07,
	ORDR.U_PMX_MOV_TXT08,
	ORDR.U_PMX_MOV_TXT09,
	ORDR.U_PMX_MOV_TXT10,
	ORDR.NumAtCard,
	ORDR.DocDueDate,
	ORDR.U_CUSTOMER_PO,
	ORDR.U_PMX_DR_SAL_ORDR,
	ORDR.Comments,
	ORDR.U_PMX_DR_NAM2,
	ORDR.U_PMX_DR_ADR2,
	ORDR.U_PMX_DR_EREM,
	ORDR.TrnspCode,
	ORDR.PickRmrk,
	convert(varchar(100),RDR1.U_PMX_DR_COMMENTS) AS U_PMX_DR_COMMENTS,
	ORDR.U_PMX_MOV_TXT05 AS LanguageCode,
	PMX_PLLI.BaseLine AS LineNum,
	PMX_INVT.ItemCode,
	OITM.ItemName,
	PMX_INVT.Quantity,
	PMX_ITRI.BatchNumber AS Batchnumber,
	PMX_ITRI.BestBeforeDate AS BestBeforeDate,
	ORDR.U_PMX_MOV_TXT05 AS LanguageCode,
OITM.U_PMX_DG_CLASS AS Class,
OITM.U_PMX_DG_CTRYOFORG AS CountryOfOrigin,
OITM.U_PMX_DG_EQ AS EQ,
OITM.U_PMX_DG_HSCODE AS HSCODE,
OITM.U_PMX_DG_LABEL AS LABEL,
OITM.U_PMX_DG_LIQSOL AS Liquid_Solid,
OITM.U_PMX_DG_LQ AS LQ,
OITM.U_PMX_DG_MSDS AS MSDS,
OITM.U_PMX_DG_NWKVE AS NetWeightVKE,
OITM.U_PMX_DG_NWSKU AS NetWeightSKU,
OITM.U_PMX_DG_VOLKVE AS VolumeVKE,
OITM.U_PMX_DG_VOLSKU AS VolumeSKU,
OITM.U_PMX_DG_PKGGRP AS PackingGroup,
OITM.U_PMX_DG_TXT01 AS Freetxt01,
OITM.U_PMX_DG_TXT02 AS Freetxt02,
OITM.U_PMX_DG_TXT03 AS Freetxt03,
OITM.U_PMX_DG_TXT04 AS Freetxt04,
OITM.U_PMX_DG_TXT05 AS Freetxt05,
OITM.U_PMX_DG_TXT06 AS Freetxt06

	from PMX_MOV_PLCD
	LEFT outer JOIN ORDR on PMX_MOV_PLCD.SalesOrderDocEntry = ORDR.DocEntry
	LEFT OUTER JOIN RDR12 on ORDR.DocEntry = RDR12.DocEntry
	LEFT OUTER JOIN RDR1 on ORDR.DocEntry = RDR1.DocEntry
	LEFT OUTER JOIN PMX_INVT ON RIGHT(PMX_MOV_PLCD.ColliID,18) = RIGHT (PMX_INVT.SSCC,18)
	LEFT OUTER JOIN PMX_ITRI ON PMX_INVT.ItemTransactionalInfoKey = PMX_ITRI.InternalKey
	LEFT OUTER JOIN OITM ON PMX_INVT.ItemCode = OITM.ItemCode
	LEFT OUTER JOIN PMX_PLLI ON PMX_PLLI.DocEntry = PMX_MOV_PLCD.PickListDocEntry AND PMX_PLLI.ItemCode = OITM.ItemCode
	WHERE  PMX_MOV_PLCD.PickListDocEntry = @PickListDocEntry and PMX_MOV_PLCD.SalesOrderDocEntry = @SalesOrderDocEntry

	GROUP BY

	PMX_MOV_PLCD.InternalKey, PMX_MOV_PLCD.PickListDocEntry, PMX_MOV_PLCD.SalesOrderDocEntry,convert(date,PMX_MOV_PLCD.CreateDateTime,106), PMX_MOV_PLCD.ColliID, PMX_MOV_PLCD.Carrier,
	PMX_MOV_PLCD.Width, PMX_MOV_PLCD.Length, PMX_MOV_PLCD.Height, PMX_MOV_PLCD.Weight, PMX_MOV_PLCD.PalletID ,
	ORDR.CardName,
	RDR12.StreetS,
	RDR12.CityS,
	RDR12.ZipCodeS,
	RDR12.CountryS,
	PMX_MOV_PLCD.AWBNr,
	ORDR.U_PMX_MOV_TXT01,
	ORDR.U_PMX_MOV_TXT02,
	ORDR.U_PMX_MOV_TXT03,
	ORDR.U_PMX_MOV_TXT04,
	ORDR.U_PMX_MOV_TXT06,
	ORDR.U_PMX_MOV_TXT07,
	ORDR.U_PMX_MOV_TXT08,
	ORDR.U_PMX_MOV_TXT09,
	ORDR.U_PMX_MOV_TXT10,
	ORDR.NumAtCard,
	ORDR.DocDueDate,
	ORDR.U_CUSTOMER_PO,
	ORDR.U_PMX_DR_SAL_ORDR,
	ORDR.Comments,
	ORDR.U_PMX_DR_NAM2,
	ORDR.U_PMX_DR_ADR2,
	ORDR.U_PMX_DR_EREM,
	ORDR.TrnspCode,
	ORDR.PickRmrk,
	convert(varchar(100),RDR1.U_PMX_DR_COMMENTS ),---AS U_PMX_DRT_COMMENTS,
	ORDR.U_PMX_MOV_TXT05 ,
	PMX_PLLI.BaseLine, -- AS LineNum,
	PMX_INVT.ItemCode,
	OITM.ItemName,
	PMX_INVT.Quantity,
	PMX_ITRI.BatchNumber ,
	PMX_ITRI.BestBeforeDate,
	ORDR.U_PMX_MOV_TXT05 ,
OITM.U_PMX_DG_CLASS ,
OITM.U_PMX_DG_CTRYOFORG ,
OITM.U_PMX_DG_EQ ,
OITM.U_PMX_DG_HSCODE,
OITM.U_PMX_DG_LABEL ,
OITM.U_PMX_DG_LIQSOL ,
OITM.U_PMX_DG_LQ ,
OITM.U_PMX_DG_MSDS ,
OITM.U_PMX_DG_NWKVE ,
OITM.U_PMX_DG_NWSKU ,
OITM.U_PMX_DG_VOLKVE ,
OITM.U_PMX_DG_VOLSKU ,
OITM.U_PMX_DG_PKGGRP ,
OITM.U_PMX_DG_TXT01 ,
OITM.U_PMX_DG_TXT02 ,
OITM.U_PMX_DG_TXT03 ,
OITM.U_PMX_DG_TXT04 ,
OITM.U_PMX_DG_TXT05 ,
OITM.U_PMX_DG_TXT06

END